clear
close

global field;
field = imread('pic3.bmp');
global xsize;
global ysize;
xsize = size(field,1);
ysize = size(field,2);
numberofparticles = 200;
positiony = 10;
positionx = 80;
positiona = pi/4;
ratio = 0.9;

movementx = [-1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1 -1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0 ]                                                                                                 
movementy = [ 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0 ]


for i = 1:numberofparticles
    particlesx(i) = floor(rand*(xsize-2))+2;
    particlesy(i) = floor(rand*(ysize-2))+2;
    particlesa(i) = floor(pi/4);
    w(i) = 1/numberofparticles;
end

figure('Position',[300 300 300+2*xsize 300+2*ysize])

for i = 1:length(movementy)
    mx = measure(positionx, positiony, positiona);
    for j = 1:numberofparticles
        px(j,:) = measure(particlesx(j), particlesy(j), particlesa(j));
        w(j) = gdist(mx,px(j,:));
    end
    w = w/sum(w);

    samples = sampling3(w,numberofparticles);
    wold = w;
    particlesxold = particlesx;
    particlesyold = particlesy;
    for j = 1:numberofparticles*ratio
        randnx = 1000000;
        randny = 1000000;
        while ~(((particlesxold(samples(j))+randnx) >2) && ((particlesxold(samples(j))+randnx) < (xsize-2)) && ((particlesyold(samples(j))+randny) >2) && ((particlesyold(samples(j))+randny) < (ysize-2)))
            randnx = randn*0.2;
            randny = randn*0.2;
        end
        particlesx(j) = particlesxold(samples(j))+randnx;
        particlesy(j) = particlesyold(samples(j))+randny;
        
        w(j) = wold(samples(j));
    end
    for j = (numberofparticles*ratio+1):numberofparticles
        particlesx(j) = floor(rand*(xsize-4))+2;
        particlesy(j) = floor(rand*(xsize-4))+2;
        w(j) = (1-ratio)/numberofparticles;
    end
    
    positionx = positionx + movementx(i);
    positiony = positiony + movementy(i);
    particlesx (particlesx + movementx(i) < xsize-2) = particlesx(particlesx + movementx(i) < xsize-2) + movementx(i);
    particlesy (particlesy + movementy(i) < ysize-2) = particlesy(particlesy + movementy(i) < ysize-2) + movementy(i);
    
    clf(1)
    hold on
    image(field(:,:,1)');
    axis([0 100 0 100]);
    
    scatter(particlesx, particlesy,w*10000,'.r');
    scatter(positionx,positiony,'.b')
    pause(0.01);
    hold on
end




    
